#!/usr/bin/python

#opcode comparator - take in disassembly from two different sources (assuming at&t), and compare the results based on "opcodename" "operand1", "operand2"
from sys import *

# known to be wrong in pydasm
#knownbad = { 'pmaxub' : 'pmaxsw', 'unpckhps' : 'unpcklps', 'punpckhwd':'punpckhbd' ,'cmovc':'cmovb', 'cmovnc':'cmovae', 'cmovz':'cmove', 'cmovnz':'cmovne', 'cmovpe':'cmovp', 'cmovpo':'cmovnp', 'packsswb':'packusdw', 'packuswb':'packsswb', 'jbe':'jna', 'jpe':'jp', 'jge':'jnl', 'jle':'jng', 'setc':'setb', 'setnc':'setnb','seta':'setnbe','setpe':'setp','setpo':'setnp','setge':'setnl','setg':'setnle','pextrw':'pextrv', 'cdwe':'cbw', 'cdq':'cwd' }
knownbad = {}

#simple "does it work" test
from disassemble import *
import disassemble22 as d
from pydasm import *
for i in range(256):
    buf = "%c%c%c%c%c%c%c%c%c%c"%(int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
    buf2 = "ABCDEFGHIJKLMNOP%c%c%c%c%c%c%c%c%c%c"%(int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
    d22 = None
    d25 = None
    try:
        d22= d.Opcode(buf).printOpcode(0).strip('\n\r \t')
        d25= Opcode(buf2,16).printOpcode(0).strip('\n\r \t')
    except:
        d22 = "ERROR WITH OPCODE OR NONE"
    if not (d22 == "invalid" or d22== "ERROR WITH OPCODE OR NONE"):
        if (d22 != d25):
            print "\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),d22,d25)

stdin.readline()

for j in range(256):
    for i in range(256):
        buf = "\x0f%c%c%c%c%c%c%c%c"%(int(j),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
        buf2 = "ABCDEFGHIJKLMNOP\x0f%c%c%c%c%c%c%c%c"%(int(j),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
        d22 = None
        d25 = None
        try:
            d22= d.Opcode(buf).printOpcode(0).strip('\n\r \t')
            d25= Opcode(buf2,16).printOpcode(0).strip('\n\r \t')
            if not (d22 == "invalid" or d22== "ERROR WITH OPCODE OR NONE"):
                if (d22 != d25):
                    #print "\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),ld,pd)
                    print "\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),d22,d25)
        except:
            x,y,z = exc_info()
            excepthook(x,y,z)
            d22 = "ERROR WITH OPCODE OR NONE"

stdin.readline()

for j in range(256):
    for i in range(256):
        buf = "\x66\x0f%c%c%c%c%c%c%c%c"%(int(j),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
        d22 = None
        d25 = None
        try:
            d22= d.Opcode(buf).printOpcode(0).strip('\n\r \t')
            d25= Opcode(buf).printOpcode(0).strip('\n\r \t')
            if not (d22 == "invalid" or d22== "ERROR WITH OPCODE OR NONE"):
                if (d22 != d25):
                    #print "\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),ld,pd)
                    print "\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),d22,d25)
        except:
            x,y,z = exc_info()
            excepthook(x,y,z)
            d22 = "ERROR WITH OPCODE OR NONE"

stdin.readline()




for j in range(256):
    for i in range(256):
        buf = "\xF2\x0f%c%c%c%c%c%c%c%c"%(int(j),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
        d22 = None
        d25 = None
        try:
            d22= d.Opcode(buf).printOpcode(0).strip('\n\r \t')
            d25= Opcode(buf).printOpcode(0).strip('\n\r \t')
            if not (d22 == "invalid" or d22== "ERROR WITH OPCODE OR NONE"):
                if (d22 != d25):
                    #print "\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),ld,pd)
                    print "\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),d22,d25)
        except:
            x,y,z = exc_info()
            excepthook(x,y,z)
            d22 = "ERROR WITH OPCODE OR NONE"

stdin.readline()

for j in range(256):
    for i in range(256):
        buf = "\xF3\x0f%c%c%c%c%c%c%c%c"%(int(j),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
        d22 = None
        d25 = None
        try:
            d22= d.Opcode(buf).printOpcode(0).strip('\n\r \t')
            d25= Opcode(buf).printOpcode(0).strip('\n\r \t')
            if not (d22 == "invalid" or d22== "ERROR WITH OPCODE OR NONE"):
                if (d22 != d25):
                    #print "\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),ld,pd)
                    print "\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),d22,d25)
    
        except:
            x,y,z = exc_info()
            excepthook(x,y,z)
            d22 = "ERROR WITH OPCODE OR NONE"


