#opcode comparator - take in disassembly from two different sources (assuming at&t), and compare the results based on "opcodename" "operand1", "operand2"
from sys import *

# known to be wrong in pydasm
knownbad = { 'pmaxub' : 'pmaxsw', 'unpckhps' : 'unpcklps', 'punpckhwd':'punpckhbd' ,'cmovc':'cmovb', 'cmovnc':'cmovae', 'cmovz':'cmove', 'cmovnz':'cmovne', 'cmovpe':'cmovp', 'cmovpo':'cmovnp', 'packsswb':'packusdw', 'packuswb':'packsswb', 'jbe':'jna', 'jpe':'jp', 'jge':'jnl', 'jle':'jng', 'setc':'setb', 'setnc':'setnb','seta':'setnbe','setpe':'setp','setpo':'setnp','setge':'setnl','setg':'setnle','pextrw':'pextrv', 'cdwe':'cbw', 'cdq':'cwd' }


#simple "does it work" test
from disassemble import *
from pydasm import *
for i in range(256):
    buf = "%c%c%c%c%c%c%c%c%c%c"%(int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
    ld = None
    pd = get_instruction_string(get_instruction(buf,MODE_32),FORMAT_ATT,0)
    try:
        ld = Opcode(buf).printOpcode(0).replace(', 1)', ')')
    except:
        ld = "ERROR WITH OPCODE OR NONE"
    if not (not pd and ld == "invalid"):
        if (ld and pd and ld.replace(' ','').replace(', 1)', ')') != pd.replace(' ','')):
            print "\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),ld,pd)


for j in range(256):
    for i in range(256):
        buf = "\x0f%c%c%c%c%c%c%c%c"%(int(j),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
        ld = None
        pd = get_instruction_string(get_instruction(buf,MODE_32),FORMAT_ATT,0)
        try:
            ldo = Opcode(buf)
            ld = ldo.printOpcode(0).replace(', 1)', ')')
            if ldo.opcode in knownbad.keys():
                ld = ld.replace(ldo.opcode, knownbad[ldo.opcode])
            if (ldo.getSize() <3):
                continue
        except:
            x,y,z = exc_info()
            excepthook(x,y,z)
            ld = "ERROR WITH OPCODE OR NONE"
        if not (not pd and ld == "invalid"):
            if (ld and pd and ld.replace(' ','').replace(', 1)', ')') != pd.replace(' ','')):
                #print "\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),int(i),ld,pd)
                print "\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),ld,pd)


for j in range(256):
    for i in range(256):
        buf = "\x66\x0f%c%c%c%c%c%c%c%c"%(int(j),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
        ld = None
        pd = get_instruction_string(get_instruction(buf,MODE_32),FORMAT_ATT,0)
        try:
            ldo = Opcode(buf)
            ld = ldo.printOpcode(0).replace(', 1)', ')')
            if ldo.opcode in knownbad.keys():
                ld = ld.replace(ldo.opcode, knownbad[ldo.opcode])
            if (ldo.getSize() <4):
                continue
        except:
            ld = "ERROR WITH OPCODE OR NONE"
        if not (not pd and ld == "invalid"):
            if (ld and pd and ld.replace(' ','').replace(', 1)', ')') != pd.replace(' ','')):
                print "\\x66\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),ld,pd)





for j in range(256):
    for i in range(256):
        buf = "\xF2\x0f%c%c%c%c%c%c%c%c"%(int(j),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
        ld = None
        pd = get_instruction_string(get_instruction(buf,MODE_32),FORMAT_ATT,0)
        try:
            ldo = Opcode(buf)
            ld = ldo.printOpcode(0).replace(', 1)', ')')
            if ldo.opcode in knownbad.keys():
                ld = ld.replace(ldo.opcode, knownbad[ldo.opcode])
            if (ldo.getSize() <4):
                continue
        except:
            ld = "ERROR WITH OPCODE OR NONE"
        if not (not pd and ld == "invalid"):
            if (ld and pd and ld.replace(' ','').replace(', 1)', ')') != pd.replace(' ','')):
                print "\\xF2\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),ld,pd)



for j in range(256):
    for i in range(256):
        buf = "\xF3\x0f%c%c%c%c%c%c%c%c"%(int(j),int(i),int(i),int(i),int(i),int(i),int(i),int(i))
        ld = None
        pd = get_instruction_string(get_instruction(buf,MODE_32),FORMAT_ATT,0)
        try:
            ldo = Opcode(buf)
            ld = ldo.printOpcode(0).replace(', 1)', ')')
            if ldo.opcode in knownbad.keys():
                ld = ld.replace(ldo.opcode, knownbad[ldo.opcode])
            if (ldo.getSize() <4):
                continue
        except:
            ld = "ERROR WITH OPCODE OR NONE"
        if not (not pd and ld == "invalid"):
            if (ld and pd and ld.replace(' ','').replace(', 1)', ')') != pd.replace(' ','')):
                print "\\xF3\\x0f\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x\\x%02x:          %s\t\t\t%s"%(j,int(i),int(i),int(i),int(i),int(i),int(i),int(i),ld,pd)



