#!/usr/bin/python
import disassemble as dc
import disassemble25 as do
import time
import pickle
from cStringIO import StringIO
from Elf import *

e=Elf('/bin/bash')
text=e.getSection('.text').getBytes()
textlen = len(text)
off=0
o=[]

time.sleep(1)

t= time.time()
while off < textlen:
  op=dc.Opcode(text,off)
  o.append(op)
  off += op.getSize()

td=time.time()-t
ns = StringIO()
pickle.dump(o,ns)
ns.seek(0)
print "New Library: %f secs at %d pickle-bytes"%(td,len(ns.read()))

off=0
o=[]

time.sleep(1)

t= time.time()
while off < textlen:
  op=do.Opcode(text,off)
  o.append(op)
  off += op.getSize()

td=time.time()-t
os = StringIO()
pickle.dump(o,os)
os.seek(0)
print "Old Library: %f secs at %d pickle-bytes"%(td,len(os.read()))
